System.registerDynamic("ng2-foundation/components/accordion/accordion.component", ["@angular/core"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this,
      GLOBAL = this;
  var __decorate = (this && this.__decorate) || function(decorators, target, key, desc) {
    var c = arguments.length,
        r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
        d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
      r = Reflect.decorate(decorators, target, key, desc);
    else
      for (var i = decorators.length - 1; i >= 0; i--)
        if (d = decorators[i])
          r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
  };
  var __metadata = (this && this.__metadata) || function(k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
      return Reflect.metadata(k, v);
  };
  var core_1 = $__require('@angular/core');
  var AccordionComponent = (function() {
    function AccordionComponent() {
      this.addClass = true;
      this.groups = [];
    }
    AccordionComponent.prototype.closeOtherPanels = function(openGroup) {
      if (!this.closeOthers) {
        return;
      }
      this.groups.forEach(function(group) {
        if (group !== openGroup) {
          group.isOpen = false;
        }
      });
    };
    AccordionComponent.prototype.addGroup = function(group) {
      this.groups.push(group);
    };
    AccordionComponent.prototype.removeGroup = function(group) {
      var index = this.groups.indexOf(group);
      if (index !== -1) {
        this.groups.splice(index, 1);
      }
    };
    __decorate([core_1.Input(), __metadata('design:type', Boolean)], AccordionComponent.prototype, "closeOthers", void 0);
    __decorate([core_1.HostBinding('class.accordian'), __metadata('design:type', Boolean)], AccordionComponent.prototype, "addClass", void 0);
    AccordionComponent = __decorate([core_1.Component({
      selector: 'accordion',
      template: "<ul class=\"accordion\"><ng-content></ng-content></ul>"
    }), __metadata('design:paramtypes', [])], AccordionComponent);
    return AccordionComponent;
  }());
  exports.AccordionComponent = AccordionComponent;
  return module.exports;
});

System.registerDynamic("ng2-foundation/components/accordion/accordion-group.component", ["@angular/core", "@angular/common", "../collapse", "./accordion.component"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this,
      GLOBAL = this;
  var __decorate = (this && this.__decorate) || function(decorators, target, key, desc) {
    var c = arguments.length,
        r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
        d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
      r = Reflect.decorate(decorators, target, key, desc);
    else
      for (var i = decorators.length - 1; i >= 0; i--)
        if (d = decorators[i])
          r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
  };
  var __metadata = (this && this.__metadata) || function(k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
      return Reflect.metadata(k, v);
  };
  var __param = (this && this.__param) || function(paramIndex, decorator) {
    return function(target, key) {
      decorator(target, key, paramIndex);
    };
  };
  var core_1 = $__require('@angular/core');
  var common_1 = $__require('@angular/common');
  var collapse_1 = $__require('../collapse');
  var accordion_component_1 = $__require('./accordion.component');
  var AccordionPanelComponent = (function() {
    function AccordionPanelComponent(accordion) {
      this.accordion = accordion;
    }
    Object.defineProperty(AccordionPanelComponent.prototype, "isOpen", {
      get: function() {
        return this._isOpen;
      },
      set: function(value) {
        this._isOpen = value;
        if (value) {
          this.accordion.closeOtherPanels(this);
        }
      },
      enumerable: true,
      configurable: true
    });
    AccordionPanelComponent.prototype.ngOnInit = function() {
      this.panelClass = this.panelClass || 'panel-default';
      this.accordion.addGroup(this);
    };
    AccordionPanelComponent.prototype.ngOnDestroy = function() {
      this.accordion.removeGroup(this);
    };
    AccordionPanelComponent.prototype.toggleOpen = function(event) {
      event.preventDefault();
      if (!this.isDisabled) {
        this.isOpen = !this.isOpen;
      }
    };
    __decorate([core_1.Input(), __metadata('design:type', String)], AccordionPanelComponent.prototype, "heading", void 0);
    __decorate([core_1.Input(), __metadata('design:type', String)], AccordionPanelComponent.prototype, "panelClass", void 0);
    __decorate([core_1.Input(), __metadata('design:type', Boolean)], AccordionPanelComponent.prototype, "isDisabled", void 0);
    __decorate([core_1.HostBinding('class.panel-open'), core_1.Input(), __metadata('design:type', Boolean)], AccordionPanelComponent.prototype, "isOpen", null);
    AccordionPanelComponent = __decorate([core_1.Component({
      selector: 'accordion-group, accordion-panel',
      directives: [collapse_1.CollapseDirective, common_1.NgClass, common_1.NgStyle],
      template: "\n    <li class=\"accordion-item\" [ngClass]=\"panelClass\" [class.is-active]=\"isOpen\">\n      <a href tabindex=\"0\" class=\"accordion-toggle accordion-title\" (click)=\"toggleOpen($event)\">\n        <span *ngIf=\"heading\" [ngClass]=\"{'text-muted': isDisabled}\">{{heading}}</span>\n        <ng-content select=\"[accordion-heading]\"></ng-content>\n      </a>\n      <div class=\"accordion-content\" [ngStyle]=\"{display: isOpen ? 'block' : 'none'}\" [collapse]=\"!isOpen\">\n        <ng-content></ng-content>\n      </div>\n    </li>\n  "
    }), __param(0, core_1.Inject(accordion_component_1.AccordionComponent)), __metadata('design:paramtypes', [accordion_component_1.AccordionComponent])], AccordionPanelComponent);
    return AccordionPanelComponent;
  }());
  exports.AccordionPanelComponent = AccordionPanelComponent;
  return module.exports;
});

System.registerDynamic("ng2-foundation/components/accordion", ["./accordion/accordion.component", "./accordion/accordion-group.component"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this,
      GLOBAL = this;
  var accordion_component_1 = $__require('./accordion/accordion.component');
  var accordion_group_component_1 = $__require('./accordion/accordion-group.component');
  var accordion_component_2 = $__require('./accordion/accordion.component');
  exports.AccordionComponent = accordion_component_2.AccordionComponent;
  var accordion_group_component_2 = $__require('./accordion/accordion-group.component');
  exports.AccordionPanelComponent = accordion_group_component_2.AccordionPanelComponent;
  exports.ACCORDION_DIRECTIVES = [accordion_component_1.AccordionComponent, accordion_group_component_1.AccordionPanelComponent];
  return module.exports;
});

System.registerDynamic("ng2-foundation/components/alert/alert.component", ["@angular/core", "@angular/common"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this,
      GLOBAL = this;
  var __decorate = (this && this.__decorate) || function(decorators, target, key, desc) {
    var c = arguments.length,
        r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
        d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
      r = Reflect.decorate(decorators, target, key, desc);
    else
      for (var i = decorators.length - 1; i >= 0; i--)
        if (d = decorators[i])
          r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
  };
  var __metadata = (this && this.__metadata) || function(k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
      return Reflect.metadata(k, v);
  };
  var core_1 = $__require('@angular/core');
  var common_1 = $__require('@angular/common');
  var ALERT_TEMPLATE = "\n  <div class=\"callout\" role=\"alert\" [ngClass]=\"(type || '')\" *ngIf=\"!closed\">\n    <ng-content></ng-content>\n    <button *ngIf=\"closeable\"\n            type=\"button\"\n            class=\"close-button\"\n            aria-label=\"Close alert\"\n            type=\"button\"\n            (click)=\"onClose()\">\n      <span aria-hidden=\"true\">&times;</span>\n    </button>\n  </div>\n  ";
  var AlertComponent = (function() {
    function AlertComponent() {
      this.type = 'warning';
      this.close = new core_1.EventEmitter(false);
    }
    AlertComponent.prototype.onClose = function() {
      this.closed = true;
      this.close.emit(this);
    };
    __decorate([core_1.Input(), __metadata('design:type', String)], AlertComponent.prototype, "type", void 0);
    __decorate([core_1.Input(), __metadata('design:type', Boolean)], AlertComponent.prototype, "closeable", void 0);
    __decorate([core_1.Output(), __metadata('design:type', core_1.EventEmitter)], AlertComponent.prototype, "close", void 0);
    AlertComponent = __decorate([core_1.Component({
      selector: 'alert',
      directives: [common_1.NgIf, common_1.NgClass],
      template: ALERT_TEMPLATE
    }), __metadata('design:paramtypes', [])], AlertComponent);
    return AlertComponent;
  }());
  exports.AlertComponent = AlertComponent;
  return module.exports;
});

System.registerDynamic("ng2-foundation/components/alert", ["./alert/alert.component"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this,
      GLOBAL = this;
  var alert_component_1 = $__require('./alert/alert.component');
  exports.AlertComponent = alert_component_1.AlertComponent;
  return module.exports;
});

System.registerDynamic("ng2-foundation/components/buttons/button-checkbox.directive", ["@angular/core", "@angular/common", "./button.constants"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this,
      GLOBAL = this;
  var __decorate = (this && this.__decorate) || function(decorators, target, key, desc) {
    var c = arguments.length,
        r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
        d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
      r = Reflect.decorate(decorators, target, key, desc);
    else
      for (var i = decorators.length - 1; i >= 0; i--)
        if (d = decorators[i])
          r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
  };
  var __metadata = (this && this.__metadata) || function(k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
      return Reflect.metadata(k, v);
  };
  var __param = (this && this.__param) || function(paramIndex, decorator) {
    return function(target, key) {
      decorator(target, key, paramIndex);
    };
  };
  var core_1 = $__require('@angular/core');
  var common_1 = $__require('@angular/common');
  var button_constants_1 = $__require('./button.constants');
  var ButtonCheckboxDirective = (function() {
    function ButtonCheckboxDirective(cd) {
      this.state = false;
      this.onChange = Function.prototype;
      this.onTouched = Function.prototype;
      this.cd = cd;
      cd.valueAccessor = this;
    }
    ButtonCheckboxDirective.prototype.onClick = function() {
      this.toggle(!this.state);
      this.cd.viewToModelUpdate(this.value);
    };
    ButtonCheckboxDirective.prototype.ngOnInit = function() {
      this.toggle(this.trueValue === this.value);
    };
    Object.defineProperty(ButtonCheckboxDirective.prototype, "trueValue", {
      get: function() {
        return typeof this.btnCheckboxTrue !== 'undefined' ? this.btnCheckboxTrue : true;
      },
      enumerable: true,
      configurable: true
    });
    Object.defineProperty(ButtonCheckboxDirective.prototype, "falseValue", {
      get: function() {
        return typeof this.btnCheckboxFalse !== 'undefined' ? this.btnCheckboxFalse : false;
      },
      enumerable: true,
      configurable: true
    });
    ButtonCheckboxDirective.prototype.toggle = function(state) {
      this.state = state;
      this.value = this.state ? this.trueValue : this.falseValue;
    };
    ButtonCheckboxDirective.prototype.writeValue = function(value) {
      this.state = this.trueValue === value;
      this.value = value;
    };
    ButtonCheckboxDirective.prototype.registerOnChange = function(fn) {
      this.onChange = fn;
    };
    ButtonCheckboxDirective.prototype.registerOnTouched = function(fn) {
      this.onTouched = fn;
    };
    __decorate([core_1.Input(), __metadata('design:type', Object)], ButtonCheckboxDirective.prototype, "btnCheckboxTrue", void 0);
    __decorate([core_1.Input(), __metadata('design:type', Object)], ButtonCheckboxDirective.prototype, "btnCheckboxFalse", void 0);
    __decorate([core_1.HostBinding("class." + button_constants_1.activeClass), __metadata('design:type', Boolean)], ButtonCheckboxDirective.prototype, "state", void 0);
    __decorate([core_1.HostListener(button_constants_1.toggleEvent), __metadata('design:type', Function), __metadata('design:paramtypes', []), __metadata('design:returntype', void 0)], ButtonCheckboxDirective.prototype, "onClick", null);
    ButtonCheckboxDirective = __decorate([core_1.Directive({selector: '[btnCheckbox][ngModel]'}), __param(0, core_1.Self()), __metadata('design:paramtypes', [common_1.NgModel])], ButtonCheckboxDirective);
    return ButtonCheckboxDirective;
  }());
  exports.ButtonCheckboxDirective = ButtonCheckboxDirective;
  return module.exports;
});

System.registerDynamic("ng2-foundation/components/buttons/button.constants", [], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this,
      GLOBAL = this;
  exports.activeClass = 'hollow';
  exports.toggleEvent = 'click';
  return module.exports;
});

System.registerDynamic("ng2-foundation/components/buttons/button-radio.directive", ["@angular/core", "@angular/common", "./button.constants"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this,
      GLOBAL = this;
  var __decorate = (this && this.__decorate) || function(decorators, target, key, desc) {
    var c = arguments.length,
        r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
        d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
      r = Reflect.decorate(decorators, target, key, desc);
    else
      for (var i = decorators.length - 1; i >= 0; i--)
        if (d = decorators[i])
          r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
  };
  var __metadata = (this && this.__metadata) || function(k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
      return Reflect.metadata(k, v);
  };
  var __param = (this && this.__param) || function(paramIndex, decorator) {
    return function(target, key) {
      decorator(target, key, paramIndex);
    };
  };
  var core_1 = $__require('@angular/core');
  var common_1 = $__require('@angular/common');
  var button_constants_1 = $__require('./button.constants');
  var ButtonRadioDirective = (function() {
    function ButtonRadioDirective(cd, el) {
      this.onChange = Function.prototype;
      this.onTouched = Function.prototype;
      this.cd = cd;
      this.el = el;
      cd.valueAccessor = this;
    }
    Object.defineProperty(ButtonRadioDirective.prototype, "isActive", {
      get: function() {
        return this.btnRadio === this.value;
      },
      enumerable: true,
      configurable: true
    });
    ButtonRadioDirective.prototype.onClick = function() {
      if (this.uncheckable && this.btnRadio === this.value) {
        return this.cd.viewToModelUpdate(void 0);
      }
      this.cd.viewToModelUpdate(this.btnRadio);
    };
    ButtonRadioDirective.prototype.ngOnInit = function() {
      this.uncheckable = typeof this.uncheckable !== 'undefined';
    };
    Object.defineProperty(ButtonRadioDirective.prototype, "value", {
      get: function() {
        return this.cd.viewModel;
      },
      set: function(value) {
        this.cd.viewModel = value;
      },
      enumerable: true,
      configurable: true
    });
    ButtonRadioDirective.prototype.writeValue = function(value) {
      this.value = value;
    };
    ButtonRadioDirective.prototype.registerOnChange = function(fn) {
      this.onChange = fn;
    };
    ButtonRadioDirective.prototype.registerOnTouched = function(fn) {
      this.onTouched = fn;
    };
    __decorate([core_1.Input(), __metadata('design:type', String)], ButtonRadioDirective.prototype, "btnRadio", void 0);
    __decorate([core_1.Input(), __metadata('design:type', Boolean)], ButtonRadioDirective.prototype, "uncheckable", void 0);
    __decorate([core_1.HostBinding("class." + button_constants_1.activeClass), __metadata('design:type', Boolean)], ButtonRadioDirective.prototype, "isActive", null);
    __decorate([core_1.HostListener(button_constants_1.toggleEvent), __metadata('design:type', Function), __metadata('design:paramtypes', []), __metadata('design:returntype', void 0)], ButtonRadioDirective.prototype, "onClick", null);
    ButtonRadioDirective = __decorate([core_1.Directive({selector: '[btnRadio][ngModel]'}), __param(0, core_1.Self()), __metadata('design:paramtypes', [common_1.NgModel, core_1.ElementRef])], ButtonRadioDirective);
    return ButtonRadioDirective;
  }());
  exports.ButtonRadioDirective = ButtonRadioDirective;
  return module.exports;
});

System.registerDynamic("ng2-foundation/components/buttons", ["./buttons/button-checkbox.directive", "./buttons/button-radio.directive"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this,
      GLOBAL = this;
  var button_checkbox_directive_1 = $__require('./buttons/button-checkbox.directive');
  var button_radio_directive_1 = $__require('./buttons/button-radio.directive');
  var button_checkbox_directive_2 = $__require('./buttons/button-checkbox.directive');
  exports.ButtonCheckboxDirective = button_checkbox_directive_2.ButtonCheckboxDirective;
  var button_radio_directive_2 = $__require('./buttons/button-radio.directive');
  exports.ButtonRadioDirective = button_radio_directive_2.ButtonRadioDirective;
  exports.BUTTON_DIRECTIVES = [button_checkbox_directive_1.ButtonCheckboxDirective, button_radio_directive_1.ButtonRadioDirective];
  return module.exports;
});

System.registerDynamic("ng2-foundation/components/collapse/collapse.directive", ["@angular/core"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this,
      GLOBAL = this;
  var __decorate = (this && this.__decorate) || function(decorators, target, key, desc) {
    var c = arguments.length,
        r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
        d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
      r = Reflect.decorate(decorators, target, key, desc);
    else
      for (var i = decorators.length - 1; i >= 0; i--)
        if (d = decorators[i])
          r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
  };
  var __metadata = (this && this.__metadata) || function(k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
      return Reflect.metadata(k, v);
  };
  var core_1 = $__require('@angular/core');
  var CollapseDirective = (function() {
    function CollapseDirective(_el, _renderer) {
      this.isExpanded = true;
      this.isCollapsed = false;
      this.isCollapse = true;
      this.isCollapsing = false;
      this._el = _el;
      this._renderer = _renderer;
    }
    Object.defineProperty(CollapseDirective.prototype, "collapse", {
      get: function() {
        return this.isExpanded;
      },
      set: function(value) {
        this.isExpanded = value;
        this.toggle();
      },
      enumerable: true,
      configurable: true
    });
    CollapseDirective.prototype.ngOnInit = function() {};
    CollapseDirective.prototype.toggle = function() {
      if (this.isExpanded) {
        this.hide();
      } else {
        this.show();
      }
    };
    CollapseDirective.prototype.hide = function() {
      this.isCollapse = false;
      this.isCollapsing = true;
      this.isExpanded = false;
      this.isCollapsed = true;
      this.isCollapse = true;
      this.isCollapsing = false;
      this.display = 'none';
    };
    CollapseDirective.prototype.show = function() {
      this.isCollapse = false;
      this.isCollapsing = true;
      this.isExpanded = true;
      this.isCollapsed = false;
      this.display = 'block';
      this.isCollapse = true;
      this.isCollapsing = false;
      this._renderer.setElementStyle(this._el.nativeElement, 'overflow', 'visible');
      this._renderer.setElementStyle(this._el.nativeElement, 'height', 'auto');
    };
    __decorate([core_1.HostBinding('style.display'), __metadata('design:type', String)], CollapseDirective.prototype, "display", void 0);
    __decorate([core_1.HostBinding('class.in'), core_1.HostBinding('attr.aria-expanded'), __metadata('design:type', Boolean)], CollapseDirective.prototype, "isExpanded", void 0);
    __decorate([core_1.HostBinding('attr.aria-hidden'), __metadata('design:type', Boolean)], CollapseDirective.prototype, "isCollapsed", void 0);
    __decorate([core_1.HostBinding('class.collapse'), __metadata('design:type', Boolean)], CollapseDirective.prototype, "isCollapse", void 0);
    __decorate([core_1.HostBinding('class.collapsing'), __metadata('design:type', Boolean)], CollapseDirective.prototype, "isCollapsing", void 0);
    __decorate([core_1.Input(), __metadata('design:type', Boolean), __metadata('design:paramtypes', [Boolean])], CollapseDirective.prototype, "collapse", null);
    CollapseDirective = __decorate([core_1.Directive({selector: '[collapse]'}), __metadata('design:paramtypes', [core_1.ElementRef, core_1.Renderer])], CollapseDirective);
    return CollapseDirective;
  }());
  exports.CollapseDirective = CollapseDirective;
  return module.exports;
});

System.registerDynamic("ng2-foundation/components/collapse", ["./collapse/collapse.directive"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this,
      GLOBAL = this;
  var collapse_directive_1 = $__require('./collapse/collapse.directive');
  exports.CollapseDirective = collapse_directive_1.CollapseDirective;
  return module.exports;
});

System.registerDynamic("ng2-foundation/components/pagination/pagination.component", ["@angular/core", "@angular/common"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this,
      GLOBAL = this;
  var __decorate = (this && this.__decorate) || function(decorators, target, key, desc) {
    var c = arguments.length,
        r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
        d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
      r = Reflect.decorate(decorators, target, key, desc);
    else
      for (var i = decorators.length - 1; i >= 0; i--)
        if (d = decorators[i])
          r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
  };
  var __metadata = (this && this.__metadata) || function(k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
      return Reflect.metadata(k, v);
  };
  var __param = (this && this.__param) || function(paramIndex, decorator) {
    return function(target, key) {
      decorator(target, key, paramIndex);
    };
  };
  var core_1 = $__require('@angular/core');
  var common_1 = $__require('@angular/common');
  var paginationConfig = {
    maxSize: void 0,
    itemsPerPage: 10,
    boundaryLinks: false,
    directionLinks: true,
    firstText: 'First',
    previousText: 'Previous',
    nextText: 'Next',
    lastText: 'Last',
    rotate: true
  };
  var PAGINATION_TEMPLATE = "\n  <ul class=\"pagination\" [ngClass]=\"classMap\" role=\"navigation\" aria-label=\"Pagination\">\n    <li *ngIf=\"boundaryLinks\"\n        class=\"pagination-previous\"\n        [class.unavailable]=\"noPrevious()||disabled\">\n      <a href (click)=\"selectPage(1, $event)\" [innerHTML]=\"getText('first')\"></a>\n    </li>\n    <li *ngIf=\"directionLinks\"\n        [class.pagination-previous]=\"!boundaryLinks\"\n        [class.unavailable]=\"noPrevious()||disabled\">\n      <a href (click)=\"selectPage(page - 1, $event)\" [innerHTML]=\"getText('previous')\"></a>\n    </li>\n    <li *ngFor=\"let pg of pages; let isFirst=first; let isLast=last\"\n        [class.current]=\"pg.active\"\n        [class.unavailable]=\"disabled && !pg.active\"\n        [class.pagination-previous]=\"isFirst && !directionLinks && !boundaryLinks\"\n        [class.pagination-next]=\"isLast && !directionLinks && !boundaryLinks\"\n        class=\"pagination-page\">\n      <a *ngIf=\"!pg.active\" href (click)=\"selectPage(pg.number, $event)\" [innerHTML]=\"pg.text\"></a>\n      <span *ngIf=\"pg.active\">{{pg.text}}</span>\n    </li>\n    <li *ngIf=\"directionLinks\"\n        [class.pagination-next]=\"!boundaryLinks\"\n        [class.unavailable]=\"noNext()\">\n      <a href (click)=\"selectPage(page + 1, $event)\" [innerHTML]=\"getText('next')\">\n      </a>\n    </li>\n    <li *ngIf=\"boundaryLinks\"\n        class=\"pagination-next\"\n        [class.unavailable]=\"noNext()\">\n      <a href (click)=\"selectPage(totalPages, $event)\" [innerHTML]=\"getText('last')\">\n      </a>\n    </li>\n  </ul>\n  ";
  var PaginationComponent = (function() {
    function PaginationComponent(cd, renderer, elementRef) {
      this.numPages = new core_1.EventEmitter(false);
      this.pageChanged = new core_1.EventEmitter(false);
      this.onChange = Function.prototype;
      this.onTouched = Function.prototype;
      this.inited = false;
      this.cd = cd;
      this.renderer = renderer;
      this.elementRef = elementRef;
      cd.valueAccessor = this;
      this.config = this.config || paginationConfig;
    }
    Object.defineProperty(PaginationComponent.prototype, "itemsPerPage", {
      get: function() {
        return this._itemsPerPage;
      },
      set: function(v) {
        this._itemsPerPage = v;
        this.totalPages = this.calculateTotalPages();
      },
      enumerable: true,
      configurable: true
    });
    Object.defineProperty(PaginationComponent.prototype, "totalItems", {
      get: function() {
        return this._totalItems;
      },
      set: function(v) {
        this._totalItems = v;
        this.totalPages = this.calculateTotalPages();
      },
      enumerable: true,
      configurable: true
    });
    Object.defineProperty(PaginationComponent.prototype, "totalPages", {
      get: function() {
        return this._totalPages;
      },
      set: function(v) {
        this._totalPages = v;
        this.numPages.emit(v);
        if (this.inited) {
          this.selectPage(this.page);
        }
      },
      enumerable: true,
      configurable: true
    });
    Object.defineProperty(PaginationComponent.prototype, "page", {
      get: function() {
        return this._page;
      },
      set: function(value) {
        var _previous = this._page;
        this._page = (value > this.totalPages) ? this.totalPages : (value || 1);
        if (_previous === this._page || typeof _previous === 'undefined') {
          return;
        }
        this.pageChanged.emit({
          page: this._page,
          itemsPerPage: this.itemsPerPage
        });
      },
      enumerable: true,
      configurable: true
    });
    PaginationComponent.prototype.ngOnInit = function() {
      this.classMap = this.elementRef.nativeElement.getAttribute('class') || '';
      this.maxSize = typeof this.maxSize !== 'undefined' ? this.maxSize : paginationConfig.maxSize;
      this.rotate = typeof this.rotate !== 'undefined' ? this.rotate : paginationConfig.rotate;
      this.boundaryLinks = typeof this.boundaryLinks !== 'undefined' ? this.boundaryLinks : paginationConfig.boundaryLinks;
      this.directionLinks = typeof this.directionLinks !== 'undefined' ? this.directionLinks : paginationConfig.directionLinks;
      this.itemsPerPage = typeof this.itemsPerPage !== 'undefined' ? this.itemsPerPage : paginationConfig.itemsPerPage;
      this.totalPages = this.calculateTotalPages();
      this.pages = this.getPages(this.page, this.totalPages);
      this.page = this.cd.value;
      this.inited = true;
    };
    PaginationComponent.prototype.writeValue = function(value) {
      this.page = value;
      this.pages = this.getPages(this.page, this.totalPages);
    };
    PaginationComponent.prototype.getText = function(key) {
      return this[key + 'Text'] || paginationConfig[key + 'Text'];
    };
    PaginationComponent.prototype.noPrevious = function() {
      return this.page === 1;
    };
    PaginationComponent.prototype.noNext = function() {
      return this.page === this.totalPages;
    };
    PaginationComponent.prototype.registerOnChange = function(fn) {
      this.onChange = fn;
    };
    PaginationComponent.prototype.registerOnTouched = function(fn) {
      this.onTouched = fn;
    };
    PaginationComponent.prototype.selectPage = function(page, event) {
      if (event) {
        event.preventDefault();
      }
      if (!this.disabled) {
        if (event && event.target) {
          var target = event.target;
          target.blur();
        }
        this.writeValue(page);
        this.cd.viewToModelUpdate(this.page);
      }
    };
    PaginationComponent.prototype.makePage = function(num, text, isActive) {
      return {
        number: num,
        text: text,
        active: isActive
      };
    };
    PaginationComponent.prototype.getPages = function(currentPage, totalPages) {
      var pages = [];
      var startPage = 1;
      var endPage = totalPages;
      var isMaxSized = typeof this.maxSize !== 'undefined' && this.maxSize < totalPages;
      if (isMaxSized) {
        if (this.rotate) {
          startPage = Math.max(currentPage - Math.floor(this.maxSize / 2), 1);
          endPage = startPage + this.maxSize - 1;
          if (endPage > totalPages) {
            endPage = totalPages;
            startPage = endPage - this.maxSize + 1;
          }
        } else {
          startPage = ((Math.ceil(currentPage / this.maxSize) - 1) * this.maxSize) + 1;
          endPage = Math.min(startPage + this.maxSize - 1, totalPages);
        }
      }
      for (var num = startPage; num <= endPage; num++) {
        var page = this.makePage(num, num.toString(), num === currentPage);
        pages.push(page);
      }
      if (isMaxSized && !this.rotate) {
        if (startPage > 1) {
          var previousPageSet = this.makePage(startPage - 1, '...', false);
          pages.unshift(previousPageSet);
        }
        if (endPage < totalPages) {
          var nextPageSet = this.makePage(endPage + 1, '...', false);
          pages.push(nextPageSet);
        }
      }
      return pages;
    };
    PaginationComponent.prototype.calculateTotalPages = function() {
      var totalPages = this.itemsPerPage < 1 ? 1 : Math.ceil(this.totalItems / this.itemsPerPage);
      return Math.max(totalPages || 0, 1);
    };
    __decorate([core_1.Input(), __metadata('design:type', Number)], PaginationComponent.prototype, "maxSize", void 0);
    __decorate([core_1.Input(), __metadata('design:type', Boolean)], PaginationComponent.prototype, "boundaryLinks", void 0);
    __decorate([core_1.Input(), __metadata('design:type', Boolean)], PaginationComponent.prototype, "directionLinks", void 0);
    __decorate([core_1.Input(), __metadata('design:type', String)], PaginationComponent.prototype, "firstText", void 0);
    __decorate([core_1.Input(), __metadata('design:type', String)], PaginationComponent.prototype, "previousText", void 0);
    __decorate([core_1.Input(), __metadata('design:type', String)], PaginationComponent.prototype, "nextText", void 0);
    __decorate([core_1.Input(), __metadata('design:type', String)], PaginationComponent.prototype, "lastText", void 0);
    __decorate([core_1.Input(), __metadata('design:type', Boolean)], PaginationComponent.prototype, "rotate", void 0);
    __decorate([core_1.Input(), __metadata('design:type', Boolean)], PaginationComponent.prototype, "disabled", void 0);
    __decorate([core_1.Output(), __metadata('design:type', core_1.EventEmitter)], PaginationComponent.prototype, "numPages", void 0);
    __decorate([core_1.Output(), __metadata('design:type', core_1.EventEmitter)], PaginationComponent.prototype, "pageChanged", void 0);
    __decorate([core_1.Input(), __metadata('design:type', Number)], PaginationComponent.prototype, "itemsPerPage", null);
    __decorate([core_1.Input(), __metadata('design:type', Number)], PaginationComponent.prototype, "totalItems", null);
    PaginationComponent = __decorate([core_1.Component({
      selector: 'pagination[ngModel]',
      template: PAGINATION_TEMPLATE,
      directives: [common_1.NgFor, common_1.NgIf]
    }), __param(0, core_1.Self()), __metadata('design:paramtypes', [common_1.NgModel, core_1.Renderer, core_1.ElementRef])], PaginationComponent);
    return PaginationComponent;
  }());
  exports.PaginationComponent = PaginationComponent;
  return module.exports;
});

System.registerDynamic("ng2-foundation/components/pagination/pager.component", ["@angular/core", "@angular/common", "./pagination.component"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this,
      GLOBAL = this;
  var __extends = (this && this.__extends) || function(d, b) {
    for (var p in b)
      if (b.hasOwnProperty(p))
        d[p] = b[p];
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
  var __decorate = (this && this.__decorate) || function(decorators, target, key, desc) {
    var c = arguments.length,
        r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
        d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
      r = Reflect.decorate(decorators, target, key, desc);
    else
      for (var i = decorators.length - 1; i >= 0; i--)
        if (d = decorators[i])
          r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
  };
  var __metadata = (this && this.__metadata) || function(k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
      return Reflect.metadata(k, v);
  };
  var __param = (this && this.__param) || function(paramIndex, decorator) {
    return function(target, key) {
      decorator(target, key, paramIndex);
    };
  };
  var core_1 = $__require('@angular/core');
  var common_1 = $__require('@angular/common');
  var pagination_component_1 = $__require('./pagination.component');
  var pagerConfig = {
    itemsPerPage: 10,
    previousText: '« Previous',
    nextText: 'Next »',
    align: true
  };
  var PAGER_TEMPLATE = "\n    <ul class=\"pagination\">\n      <li class=\"arrow pagination-previous\"\n          [class.unavailable]=\"noPrevious()\"\n          [class.left]=\"!noPrevious()\"\n          [ngClass]=\"{'pull-right': align}\">\n        <a href (click)=\"selectPage(page - 1, $event)\">{{getText('previous')}}</a>\n      </li>\n      <li class=\"arrow pagination-next\"\n          [class.unavailable]=\"noNext()\"\n          [class.right]=\"!noNext()\"\n          [ngClass]=\"{'pull-right': align}\">\n        <a href (click)=\"selectPage(page + 1, $event)\">{{getText('next')}}</a>\n      </li>\n  </ul>\n";
  var PagerComponent = (function(_super) {
    __extends(PagerComponent, _super);
    function PagerComponent(cd, renderer, elementRef) {
      _super.call(this, cd, renderer, elementRef);
      this.config = pagerConfig;
    }
    PagerComponent = __decorate([core_1.Component({
      selector: 'pager[ngModel]',
      template: PAGER_TEMPLATE,
      directives: [common_1.NgClass],
      inputs: ['align', 'totalItems', 'itemsPerPage', 'previousText', 'nextText']
    }), __param(0, core_1.Self()), __metadata('design:paramtypes', [common_1.NgModel, core_1.Renderer, core_1.ElementRef])], PagerComponent);
    return PagerComponent;
  }(pagination_component_1.PaginationComponent));
  exports.PagerComponent = PagerComponent;
  return module.exports;
});

System.registerDynamic("ng2-foundation/components/pagination", ["./pagination/pagination.component", "./pagination/pager.component"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this,
      GLOBAL = this;
  var pagination_component_1 = $__require('./pagination/pagination.component');
  var pager_component_1 = $__require('./pagination/pager.component');
  var pagination_component_2 = $__require('./pagination/pagination.component');
  exports.PaginationComponent = pagination_component_2.PaginationComponent;
  var pager_component_2 = $__require('./pagination/pager.component');
  exports.PagerComponent = pager_component_2.PagerComponent;
  exports.PAGINATION_DIRECTIVES = [pagination_component_1.PaginationComponent, pager_component_1.PagerComponent];
  return module.exports;
});

System.registerDynamic("ng2-foundation/components/progressbar/progress.directive", ["@angular/core"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this,
      GLOBAL = this;
  var __decorate = (this && this.__decorate) || function(decorators, target, key, desc) {
    var c = arguments.length,
        r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
        d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
      r = Reflect.decorate(decorators, target, key, desc);
    else
      for (var i = decorators.length - 1; i >= 0; i--)
        if (d = decorators[i])
          r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
  };
  var __metadata = (this && this.__metadata) || function(k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
      return Reflect.metadata(k, v);
  };
  var core_1 = $__require('@angular/core');
  var progressConfig = {
    animate: true,
    max: 100
  };
  var ProgressDirective = (function() {
    function ProgressDirective() {
      this.addClass = true;
      this.bars = [];
    }
    Object.defineProperty(ProgressDirective.prototype, "max", {
      get: function() {
        return this._max;
      },
      set: function(v) {
        this._max = v;
        this.bars.forEach(function(bar) {
          bar.recalculatePercentage();
        });
      },
      enumerable: true,
      configurable: true
    });
    ProgressDirective.prototype.ngOnInit = function() {
      this.animate = this.animate !== false;
      this.max = typeof this.max === 'number' ? this.max : progressConfig.max;
    };
    ProgressDirective.prototype.addBar = function(bar) {
      if (!this.animate) {
        bar.transition = 'none';
      }
      this.bars.push(bar);
    };
    ProgressDirective.prototype.removeBar = function(bar) {
      this.bars.splice(this.bars.indexOf(bar), 1);
    };
    __decorate([core_1.Input(), __metadata('design:type', Boolean)], ProgressDirective.prototype, "animate", void 0);
    __decorate([core_1.HostBinding('attr.max'), core_1.Input(), __metadata('design:type', Number)], ProgressDirective.prototype, "max", null);
    __decorate([core_1.HostBinding('class.progress'), __metadata('design:type', Boolean)], ProgressDirective.prototype, "addClass", void 0);
    ProgressDirective = __decorate([core_1.Directive({selector: '[progress]'}), __metadata('design:paramtypes', [])], ProgressDirective);
    return ProgressDirective;
  }());
  exports.ProgressDirective = ProgressDirective;
  return module.exports;
});

System.registerDynamic("ng2-foundation/components/progressbar/bar.component", ["@angular/core", "@angular/common", "./progress.directive"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this,
      GLOBAL = this;
  var __decorate = (this && this.__decorate) || function(decorators, target, key, desc) {
    var c = arguments.length,
        r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
        d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
      r = Reflect.decorate(decorators, target, key, desc);
    else
      for (var i = decorators.length - 1; i >= 0; i--)
        if (d = decorators[i])
          r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
  };
  var __metadata = (this && this.__metadata) || function(k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
      return Reflect.metadata(k, v);
  };
  var __param = (this && this.__param) || function(paramIndex, decorator) {
    return function(target, key) {
      decorator(target, key, paramIndex);
    };
  };
  var core_1 = $__require('@angular/core');
  var common_1 = $__require('@angular/common');
  var progress_directive_1 = $__require('./progress.directive');
  var BarComponent = (function() {
    function BarComponent(progress) {
      this.percent = 0;
      this.progress = progress;
    }
    Object.defineProperty(BarComponent.prototype, "value", {
      get: function() {
        return this._value;
      },
      set: function(v) {
        if (!v && v !== 0) {
          return;
        }
        this._value = v;
        this.recalculatePercentage();
      },
      enumerable: true,
      configurable: true
    });
    BarComponent.prototype.ngOnInit = function() {
      this.progress.addBar(this);
    };
    BarComponent.prototype.ngOnDestroy = function() {
      this.progress.removeBar(this);
    };
    BarComponent.prototype.recalculatePercentage = function() {
      this.percent = +(100 * this.value / this.progress.max).toFixed(2);
      var totalPercentage = this.progress.bars.reduce(function(total, bar) {
        return total + bar.percent;
      }, 0);
      if (totalPercentage > 100) {
        this.percent -= totalPercentage - 100;
      }
    };
    __decorate([core_1.Input(), __metadata('design:type', String)], BarComponent.prototype, "type", void 0);
    __decorate([core_1.Input(), __metadata('design:type', Number)], BarComponent.prototype, "value", null);
    BarComponent = __decorate([core_1.Component({
      selector: 'bar',
      directives: [common_1.NgClass, common_1.NgStyle],
      template: "\n    <div class=\"progress-meter\"\n      style=\"min-width: 0;\"\n      role=\"progressbar\"\n      [ngStyle]=\"{width: (percent < 100 ? percent : 100) + '%', transition: transition}\"\n      aria-valuemin=\"0\"\n      [attr.aria-valuenow]=\"value\"\n      [attr.aria-valuetext]=\"percent.toFixed(0) + '%'\"\n      [attr.aria-valuemax]=\"max\">\n      <p class=\"progress-meter-text\">\n        <ng-content></ng-content>\n      </p>\n    </div>\n  "
    }), __param(0, core_1.Host()), __metadata('design:paramtypes', [progress_directive_1.ProgressDirective])], BarComponent);
    return BarComponent;
  }());
  exports.BarComponent = BarComponent;
  return module.exports;
});

System.registerDynamic("ng2-foundation/components/progressbar/progressbar.component", ["@angular/core", "./progress.directive", "./bar.component"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this,
      GLOBAL = this;
  var __decorate = (this && this.__decorate) || function(decorators, target, key, desc) {
    var c = arguments.length,
        r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
        d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
      r = Reflect.decorate(decorators, target, key, desc);
    else
      for (var i = decorators.length - 1; i >= 0; i--)
        if (d = decorators[i])
          r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
  };
  var __metadata = (this && this.__metadata) || function(k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
      return Reflect.metadata(k, v);
  };
  var core_1 = $__require('@angular/core');
  var progress_directive_1 = $__require('./progress.directive');
  var bar_component_1 = $__require('./bar.component');
  var ProgressbarComponent = (function() {
    function ProgressbarComponent() {}
    __decorate([core_1.Input(), __metadata('design:type', Boolean)], ProgressbarComponent.prototype, "animate", void 0);
    __decorate([core_1.Input(), __metadata('design:type', Number)], ProgressbarComponent.prototype, "max", void 0);
    __decorate([core_1.Input(), __metadata('design:type', String)], ProgressbarComponent.prototype, "type", void 0);
    __decorate([core_1.Input(), __metadata('design:type', Number)], ProgressbarComponent.prototype, "value", void 0);
    ProgressbarComponent = __decorate([core_1.Component({
      selector: 'progressbar',
      directives: [progress_directive_1.ProgressDirective, bar_component_1.BarComponent],
      template: "\n    <div progress\n         class=\"progress\"\n         role=\"progressbar\"\n         [animate]=\"animate\"\n         [max]=\"max\"\n         [ngClass]=\"type\">\n      <bar [value]=\"value\">\n        <ng-content></ng-content>\n      </bar>\n    </div>\n  "
    }), __metadata('design:paramtypes', [])], ProgressbarComponent);
    return ProgressbarComponent;
  }());
  exports.ProgressbarComponent = ProgressbarComponent;
  return module.exports;
});

System.registerDynamic("ng2-foundation/components/progressbar", ["./progressbar/progress.directive", "./progressbar/bar.component", "./progressbar/progressbar.component"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this,
      GLOBAL = this;
  var progress_directive_1 = $__require('./progressbar/progress.directive');
  var bar_component_1 = $__require('./progressbar/bar.component');
  var progressbar_component_1 = $__require('./progressbar/progressbar.component');
  var progress_directive_2 = $__require('./progressbar/progress.directive');
  exports.ProgressDirective = progress_directive_2.ProgressDirective;
  var bar_component_2 = $__require('./progressbar/bar.component');
  exports.BarComponent = bar_component_2.BarComponent;
  var progressbar_component_2 = $__require('./progressbar/progressbar.component');
  exports.ProgressbarComponent = progressbar_component_2.ProgressbarComponent;
  exports.PROGRESSBAR_DIRECTIVES = [progress_directive_1.ProgressDirective, bar_component_1.BarComponent, progressbar_component_1.ProgressbarComponent];
  return module.exports;
});

System.registerDynamic("ng2-foundation/components/rating/rating.component", ["@angular/core", "@angular/common"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this,
      GLOBAL = this;
  var __decorate = (this && this.__decorate) || function(decorators, target, key, desc) {
    var c = arguments.length,
        r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
        d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
      r = Reflect.decorate(decorators, target, key, desc);
    else
      for (var i = decorators.length - 1; i >= 0; i--)
        if (d = decorators[i])
          r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
  };
  var __metadata = (this && this.__metadata) || function(k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
      return Reflect.metadata(k, v);
  };
  var __param = (this && this.__param) || function(paramIndex, decorator) {
    return function(target, key) {
      decorator(target, key, paramIndex);
    };
  };
  var core_1 = $__require('@angular/core');
  var common_1 = $__require('@angular/common');
  var RatingComponent = (function() {
    function RatingComponent(cd) {
      this.onHover = new core_1.EventEmitter(false);
      this.onLeave = new core_1.EventEmitter(false);
      this.onChange = Function.prototype;
      this.onTouched = Function.prototype;
      this.cd = cd;
      cd.valueAccessor = this;
    }
    RatingComponent.prototype.ngOnInit = function() {
      this.max = typeof this.max !== 'undefined' ? this.max : 5;
      this.readonly = this.readonly === true;
      this.stateOn = typeof this.stateOn !== 'undefined' ? this.stateOn : 'fa-star';
      this.stateOff = typeof this.stateOff !== 'undefined' ? this.stateOff : 'fa-star-o';
      this.titles = typeof this.titles !== 'undefined' && this.titles.length > 0 ? this.titles : ['one', 'two', 'three', 'four', 'five'];
      this.range = this.buildTemplateObjects(this.ratingStates, this.max);
    };
    RatingComponent.prototype.writeValue = function(value) {
      if (value % 1 !== value) {
        this.value = Math.round(value);
        this.preValue = value;
        return;
      }
      this.preValue = value;
      this.value = value;
    };
    RatingComponent.prototype.enter = function(value) {
      if (!this.readonly) {
        this.value = value;
        this.onHover.emit(value);
      }
    };
    RatingComponent.prototype.reset = function() {
      this.value = this.preValue;
      this.onLeave.emit(this.value);
    };
    RatingComponent.prototype.registerOnChange = function(fn) {
      this.onChange = fn;
    };
    RatingComponent.prototype.registerOnTouched = function(fn) {
      this.onTouched = fn;
    };
    RatingComponent.prototype.buildTemplateObjects = function(ratingStates, max) {
      ratingStates = ratingStates || [];
      var count = ratingStates.length || max;
      var result = [];
      for (var i = 0; i < count; i++) {
        result.push(Object.assign({
          index: i,
          stateOn: this.stateOn,
          stateOff: this.stateOff,
          title: this.titles[i] || i + 1
        }, ratingStates[i] || {}));
      }
      return result;
    };
    RatingComponent.prototype.rate = function(value) {
      if (!this.readonly && value >= 0 && value <= this.range.length) {
        this.writeValue(value);
        this.cd.viewToModelUpdate(value);
      }
    };
    __decorate([core_1.Input(), __metadata('design:type', Number)], RatingComponent.prototype, "max", void 0);
    __decorate([core_1.Input(), __metadata('design:type', String)], RatingComponent.prototype, "stateOn", void 0);
    __decorate([core_1.Input(), __metadata('design:type', String)], RatingComponent.prototype, "stateOff", void 0);
    __decorate([core_1.Input(), __metadata('design:type', Boolean)], RatingComponent.prototype, "readonly", void 0);
    __decorate([core_1.Input(), __metadata('design:type', Array)], RatingComponent.prototype, "titles", void 0);
    __decorate([core_1.Input(), __metadata('design:type', Array)], RatingComponent.prototype, "ratingStates", void 0);
    __decorate([core_1.Output(), __metadata('design:type', core_1.EventEmitter)], RatingComponent.prototype, "onHover", void 0);
    __decorate([core_1.Output(), __metadata('design:type', core_1.EventEmitter)], RatingComponent.prototype, "onLeave", void 0);
    RatingComponent = __decorate([core_1.Component({
      selector: 'rating[ngModel]',
      directives: [common_1.NgFor],
      template: "\n    <span (mouseleave)=\"reset()\" tabindex=\"0\" role=\"slider\" aria-valuemin=\"0\" [attr.aria-valuemax]=\"range.length\" [attr.aria-valuenow]=\"value\" >\n      <template ngFor let-r [ngForOf]=\"range\" let-index=\"index\">\n        <i (mouseenter)=\"enter(index + 1)\" (click)=\"rate(index + 1)\" class=\"fa\" [ngClass]=\"index < value ? r.stateOn : r.stateOff\" [title]=\"r.title\" ></i>\n      </template>\n    </span>\n  "
    }), __param(0, core_1.Self()), __metadata('design:paramtypes', [common_1.NgModel])], RatingComponent);
    return RatingComponent;
  }());
  exports.RatingComponent = RatingComponent;
  return module.exports;
});

System.registerDynamic("ng2-foundation/components/rating", ["./rating/rating.component"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this,
      GLOBAL = this;
  var rating_component_1 = $__require('./rating/rating.component');
  exports.RatingComponent = rating_component_1.RatingComponent;
  return module.exports;
});

System.registerDynamic("ng2-foundation/components/common", ["@angular/core"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this,
      GLOBAL = this;
  var __decorate = (this && this.__decorate) || function(decorators, target, key, desc) {
    var c = arguments.length,
        r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
        d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
      r = Reflect.decorate(decorators, target, key, desc);
    else
      for (var i = decorators.length - 1; i >= 0; i--)
        if (d = decorators[i])
          r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
  };
  var __metadata = (this && this.__metadata) || function(k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
      return Reflect.metadata(k, v);
  };
  var __param = (this && this.__param) || function(paramIndex, decorator) {
    return function(target, key) {
      decorator(target, key, paramIndex);
    };
  };
  var core_1 = $__require('@angular/core');
  var NgTranscludeDirective = (function() {
    function NgTranscludeDirective(_viewRef) {
      this.viewRef = _viewRef;
    }
    Object.defineProperty(NgTranscludeDirective.prototype, "ngTransclude", {
      get: function() {
        return this._ngTransclude;
      },
      set: function(templateRef) {
        this._ngTransclude = templateRef;
        if (templateRef) {
          this.viewRef.createEmbeddedView(templateRef);
        }
      },
      enumerable: true,
      configurable: true
    });
    NgTranscludeDirective = __decorate([core_1.Directive({
      selector: '[ngTransclude]',
      properties: ['ngTransclude']
    }), __param(0, core_1.Inject(core_1.ViewContainerRef)), __metadata('design:paramtypes', [core_1.ViewContainerRef])], NgTranscludeDirective);
    return NgTranscludeDirective;
  }());
  exports.NgTranscludeDirective = NgTranscludeDirective;
  return module.exports;
});

System.registerDynamic("ng2-foundation/components/tabs/tabset.component", ["@angular/core", "@angular/common", "../common"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this,
      GLOBAL = this;
  var __decorate = (this && this.__decorate) || function(decorators, target, key, desc) {
    var c = arguments.length,
        r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
        d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
      r = Reflect.decorate(decorators, target, key, desc);
    else
      for (var i = decorators.length - 1; i >= 0; i--)
        if (d = decorators[i])
          r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
  };
  var __metadata = (this && this.__metadata) || function(k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
      return Reflect.metadata(k, v);
  };
  var core_1 = $__require('@angular/core');
  var common_1 = $__require('@angular/common');
  var common_2 = $__require('../common');
  var TabsetComponent = (function() {
    function TabsetComponent() {
      this.clazz = true;
      this.tabs = [];
      this.classMap = {};
    }
    Object.defineProperty(TabsetComponent.prototype, "vertical", {
      get: function() {
        return this._vertical;
      },
      set: function(value) {
        this._vertical = value;
        this.setClassMap();
      },
      enumerable: true,
      configurable: true
    });
    ;
    Object.defineProperty(TabsetComponent.prototype, "justified", {
      get: function() {
        return this._justified;
      },
      set: function(value) {
        this._justified = value;
        this.setClassMap();
      },
      enumerable: true,
      configurable: true
    });
    ;
    Object.defineProperty(TabsetComponent.prototype, "type", {
      get: function() {
        return this._type;
      },
      set: function(value) {
        this._type = value;
        this.setClassMap();
      },
      enumerable: true,
      configurable: true
    });
    ;
    TabsetComponent.prototype.ngOnInit = function() {
      this.type = this.type !== 'undefined' ? this.type : 'tabs';
    };
    TabsetComponent.prototype.ngOnDestroy = function() {
      this.isDestroyed = true;
    };
    TabsetComponent.prototype.addTab = function(tab) {
      this.tabs.push(tab);
      tab.active = this.tabs.length === 1 && tab.active !== false;
    };
    TabsetComponent.prototype.removeTab = function(tab) {
      var index = this.tabs.indexOf(tab);
      if (index === -1 || this.isDestroyed) {
        return;
      }
      if (tab.active && this.hasAvailableTabs(index)) {
        var newActiveIndex = this.getClosestTabIndex(index);
        this.tabs[newActiveIndex].active = true;
      }
      tab.removed.emit(tab);
      this.tabs.splice(index, 1);
    };
    TabsetComponent.prototype.getClosestTabIndex = function(index) {
      var tabsLength = this.tabs.length;
      if (!tabsLength) {
        return -1;
      }
      for (var step = 1; step <= tabsLength; step += 1) {
        var prevIndex = index - step;
        var nextIndex = index + step;
        if (this.tabs[prevIndex] && !this.tabs[prevIndex].disabled) {
          return prevIndex;
        }
        if (this.tabs[nextIndex] && !this.tabs[nextIndex].disabled) {
          return nextIndex;
        }
      }
      return -1;
    };
    TabsetComponent.prototype.hasAvailableTabs = function(index) {
      var tabsLength = this.tabs.length;
      if (!tabsLength) {
        return false;
      }
      for (var i = 0; i < tabsLength; i += 1) {
        if (!this.tabs[i].disabled && i !== index) {
          return true;
        }
      }
      return false;
    };
    TabsetComponent.prototype.setClassMap = function() {
      this.classMap = {'vertical': this.vertical};
    };
    __decorate([core_1.Input(), __metadata('design:type', Boolean)], TabsetComponent.prototype, "vertical", null);
    __decorate([core_1.Input(), __metadata('design:type', Boolean)], TabsetComponent.prototype, "justified", null);
    __decorate([core_1.Input(), __metadata('design:type', String)], TabsetComponent.prototype, "type", null);
    __decorate([core_1.HostBinding('class.tab-container'), __metadata('design:type', Boolean)], TabsetComponent.prototype, "clazz", void 0);
    TabsetComponent = __decorate([core_1.Component({
      selector: 'tabset',
      directives: [common_1.NgClass, common_2.NgTranscludeDirective],
      template: "\n    <div class=\"tabbable\">\n      <ul class=\"tabs\" [ngClass]=\"classMap\">\n        <li *ngFor=\"let tabz of tabs\"\n            class=\"tabs-title\"\n            [class.is-active]=\"tabz.active\">\n          <a (click)=\"tabz.active = true\"\n             [attr.aria-selected]=\"active\">\n            <span [ngTransclude]=\"tabz.headingRef\">{{tabz.heading}}</span>\n            <span *ngIf=\"tabz.removable\">\n              <span (click)=\"$event.preventDefault(); removeTab(tabz);\"\n                    class=\"fa fa-times\"></span>\n            </span>\n          </a>\n        </li>\n      </ul>\n      <div class=\"tabs-content\" [ngClass]=\"classMap\">\n        <ng-content></ng-content>\n      </div>\n    </div>\n  "
    }), __metadata('design:paramtypes', [])], TabsetComponent);
    return TabsetComponent;
  }());
  exports.TabsetComponent = TabsetComponent;
  return module.exports;
});

System.registerDynamic("ng2-foundation/components/tabs/tab.directive", ["@angular/core", "./tabset.component"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this,
      GLOBAL = this;
  var __decorate = (this && this.__decorate) || function(decorators, target, key, desc) {
    var c = arguments.length,
        r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
        d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
      r = Reflect.decorate(decorators, target, key, desc);
    else
      for (var i = decorators.length - 1; i >= 0; i--)
        if (d = decorators[i])
          r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
  };
  var __metadata = (this && this.__metadata) || function(k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
      return Reflect.metadata(k, v);
  };
  var core_1 = $__require('@angular/core');
  var tabset_component_1 = $__require('./tabset.component');
  var TabDirective = (function() {
    function TabDirective(tabset) {
      this.select = new core_1.EventEmitter(false);
      this.deselect = new core_1.EventEmitter(false);
      this.removed = new core_1.EventEmitter(false);
      this.addClass = true;
      this.tabset = tabset;
      this.tabset.addTab(this);
    }
    Object.defineProperty(TabDirective.prototype, "active", {
      get: function() {
        return this._active;
      },
      set: function(active) {
        var _this = this;
        if (this.disabled && active || !active) {
          if (!active) {
            this._active = active;
          }
          this.deselect.emit(this);
          return;
        }
        this._active = active;
        this.select.emit(this);
        this.tabset.tabs.forEach(function(tab) {
          if (tab !== _this) {
            tab.active = false;
          }
        });
      },
      enumerable: true,
      configurable: true
    });
    TabDirective.prototype.ngOnInit = function() {
      this.removable = !!this.removable;
    };
    TabDirective.prototype.ngOnDestroy = function() {
      this.tabset.removeTab(this);
    };
    __decorate([core_1.Input(), __metadata('design:type', String)], TabDirective.prototype, "heading", void 0);
    __decorate([core_1.Input(), __metadata('design:type', Boolean)], TabDirective.prototype, "disabled", void 0);
    __decorate([core_1.Input(), __metadata('design:type', Boolean)], TabDirective.prototype, "removable", void 0);
    __decorate([core_1.HostBinding('class.is-active'), core_1.Input(), __metadata('design:type', Boolean)], TabDirective.prototype, "active", null);
    __decorate([core_1.Output(), __metadata('design:type', core_1.EventEmitter)], TabDirective.prototype, "select", void 0);
    __decorate([core_1.Output(), __metadata('design:type', core_1.EventEmitter)], TabDirective.prototype, "deselect", void 0);
    __decorate([core_1.Output(), __metadata('design:type', core_1.EventEmitter)], TabDirective.prototype, "removed", void 0);
    __decorate([core_1.HostBinding('class.tabs-panel'), __metadata('design:type', Boolean)], TabDirective.prototype, "addClass", void 0);
    TabDirective = __decorate([core_1.Directive({selector: 'tab, [tab]'}), __metadata('design:paramtypes', [tabset_component_1.TabsetComponent])], TabDirective);
    return TabDirective;
  }());
  exports.TabDirective = TabDirective;
  return module.exports;
});

System.registerDynamic("ng2-foundation/components/tabs/tab-heading.directive", ["@angular/core", "./tab.directive"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this,
      GLOBAL = this;
  var __decorate = (this && this.__decorate) || function(decorators, target, key, desc) {
    var c = arguments.length,
        r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
        d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
      r = Reflect.decorate(decorators, target, key, desc);
    else
      for (var i = decorators.length - 1; i >= 0; i--)
        if (d = decorators[i])
          r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
  };
  var __metadata = (this && this.__metadata) || function(k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
      return Reflect.metadata(k, v);
  };
  var core_1 = $__require('@angular/core');
  var tab_directive_1 = $__require('./tab.directive');
  var TabHeadingDirective = (function() {
    function TabHeadingDirective(templateRef, tab) {
      tab.headingRef = templateRef;
    }
    TabHeadingDirective = __decorate([core_1.Directive({selector: '[tabHeading]'}), __metadata('design:paramtypes', [core_1.TemplateRef, tab_directive_1.TabDirective])], TabHeadingDirective);
    return TabHeadingDirective;
  }());
  exports.TabHeadingDirective = TabHeadingDirective;
  return module.exports;
});

System.registerDynamic("ng2-foundation/components/tabs", ["./tabs/tab.directive", "./tabs/tabset.component", "./tabs/tab-heading.directive"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this,
      GLOBAL = this;
  var tab_directive_1 = $__require('./tabs/tab.directive');
  var tabset_component_1 = $__require('./tabs/tabset.component');
  var tab_heading_directive_1 = $__require('./tabs/tab-heading.directive');
  var tab_directive_2 = $__require('./tabs/tab.directive');
  exports.TabDirective = tab_directive_2.TabDirective;
  var tabset_component_2 = $__require('./tabs/tabset.component');
  exports.TabsetComponent = tabset_component_2.TabsetComponent;
  var tab_heading_directive_2 = $__require('./tabs/tab-heading.directive');
  exports.TabHeadingDirective = tab_heading_directive_2.TabHeadingDirective;
  exports.TAB_DIRECTIVES = [tab_directive_1.TabDirective, tab_heading_directive_1.TabHeadingDirective, tabset_component_1.TabsetComponent];
  return module.exports;
});

System.registerDynamic("ng2-foundation/ng2-foundation", ["./components/accordion", "./components/alert", "./components/buttons", "./components/collapse", "./components/pagination", "./components/progressbar", "./components/rating", "./components/tabs"], true, function($__require, exports, module) {
  "use strict";
  ;
  var define,
      global = this,
      GLOBAL = this;
  function __export(m) {
    for (var p in m)
      if (!exports.hasOwnProperty(p))
        exports[p] = m[p];
  }
  var accordion_1 = $__require('./components/accordion');
  var alert_1 = $__require('./components/alert');
  var buttons_1 = $__require('./components/buttons');
  var collapse_1 = $__require('./components/collapse');
  var pagination_1 = $__require('./components/pagination');
  var progressbar_1 = $__require('./components/progressbar');
  var rating_1 = $__require('./components/rating');
  var tabs_1 = $__require('./components/tabs');
  __export($__require('./components/accordion'));
  __export($__require('./components/alert'));
  __export($__require('./components/buttons'));
  __export($__require('./components/collapse'));
  __export($__require('./components/pagination'));
  __export($__require('./components/progressbar'));
  __export($__require('./components/rating'));
  __export($__require('./components/tabs'));
  Object.defineProperty(exports, "__esModule", {value: true});
  exports.default = {
    directives: [accordion_1.ACCORDION_DIRECTIVES, alert_1.AlertComponent, buttons_1.BUTTON_DIRECTIVES, collapse_1.CollapseDirective, pagination_1.PAGINATION_DIRECTIVES, progressbar_1.PROGRESSBAR_DIRECTIVES, rating_1.RatingComponent, tabs_1.TAB_DIRECTIVES],
    providers: []
  };
  return module.exports;
});

//# sourceMappingURL=ng2-foundation.js.map